import 'signalr';
import { ILogger } from 'ts-smart-logger';
import { AnyT } from '../../definitions.interface';
import { BaseChannel } from '../base-channel.service';
export declare class SignalRChannel extends BaseChannel {
    protected static logger: ILogger;
    private signalRScriptTask;
    private signalRInitTasks;
    /**
     * @stable [21.05.2018]
     * @param {string} ip
     * @param {AnyT} config
     */
    connect(ip: string, config?: AnyT): void;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     */
    disconnect(ip: string): void;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     * @param {string} event0
     * @param {AnyT} messages
     */
    emitEvent(ip: string, event0: string, ...messages: AnyT[]): void;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     * @param {AnyT} messages
     */
    emitChannelEvent(ip: string, messages: AnyT): void;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     * @param {string} hubUrl
     */
    private onSignalRInitialize;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     * @returns {string}
     */
    private prepareIp;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     */
    private cancelInitTask;
}
