import { IUniversalButtonEntity } from '../../entities-definitions.interface';
import { IUniversalButtonConfiguration } from '../../configurations-definitions.interface';
import { IApplicationMessagesSettings } from '../../settings';
export declare type UniversalButtonEntityT = IUniversalButtonEntity & IUniversalButtonConfiguration;
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @returns {boolean | undefined}
 */
export declare const isButtonDisabled: (entity: UniversalButtonEntityT) => boolean;
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {IApplicationMessagesSettings} messages
 * @returns {string}
 */
export declare const getButtonText: (entity: UniversalButtonEntityT, messages: IApplicationMessagesSettings) => string;
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {string} progressIcon
 * @param {string} errorIcon
 * @returns {string}
 */
export declare const getButtonIcon: (entity: UniversalButtonEntityT, progressIcon: string, errorIcon: string) => string;
