"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var list_1 = require("../../list");
var card_component_1 = require("../card.component");
var CardList = /** @class */ (function (_super) {
    __extends(CardList, _super);
    function CardList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [02.05.2018]
     * @returns {JSX.Element}
     */
    CardList.prototype.getView = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement("div", { ref: 'container', className: util_1.toClassName('rac-card-list', props.className) },
            this.dataSource.map(function (item) { return _this.getItem(item); }),
            this.addActionElement));
    };
    /**
     * @stable [02.05.2018]
     * @param {IEntity} entity
     * @returns {JSX.Element}
     */
    CardList.prototype.getItem = function (entity) {
        var _this = this;
        var props = this.props;
        var itemConfiguration = props.itemConfiguration;
        return (React.createElement(card_component_1.Card, { key: this.toRowKey(entity), rippable: true, className: 'rac-card-list-item', actionButtons: itemConfiguration && itemConfiguration.actionButtons
                && itemConfiguration.actionButtons(entity), actionIcons: itemConfiguration && itemConfiguration.actionIcons
                && itemConfiguration.actionIcons(entity), onClick: function () { return _this.onSelect(entity); } }, itemConfiguration.renderer(entity)));
    };
    return CardList;
}(list_1.BaseList));
exports.CardList = CardList;
//# sourceMappingURL=card-list.component.js.map