import { IApplicationDomAccessor } from './dom-accessor.interface';
import { IXYEntity } from '../../entities-definitions.interface';
export declare class DomAccessor implements IApplicationDomAccessor {
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @returns {IXYEntity}
     */
    getScrollInfo(el: Element): IXYEntity;
    /**
     * @stable [01.12.2018]
     * @param {Element} source
     * @returns {number}
     */
    getContentHeight(source: Element): number;
    /**
     * @stable [01.12.2018]
     * @param {Element} parent
     * @returns {Element}
     */
    findUniversalSelectedElement(parent: Element): Element;
    /**
     * @stable [01.12.2018]
     * @param {IXYEntity | Element} payload
     * @param {Element} parent
     */
    scrollTo(payload: IXYEntity | Element, parent?: Element): void;
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @param {number} top
     */
    setScrollTop(el: Element, top: number): void;
}
