/// <reference types="react" />
import { AnyT } from '../../../definitions.interface';
import { BasicTextField } from '../textfield';
import { IAddressFieldState, IAddressFieldProps } from './addressfield.interface';
export declare class AddressField extends BasicTextField<AddressField, IAddressFieldProps, IAddressFieldState> {
    static defaultProps: IAddressFieldProps;
    private static readonly ADDRESS_MARKER;
    private autocomplete;
    private geoCoderTask;
    private lat;
    private lng;
    private placeId;
    private placeEntity;
    private geoCoder;
    /**
     * @stable [29.07.2018]
     * @param {IAddressFieldProps} props
     */
    constructor(props: IAddressFieldProps);
    /**
     * @stable [30.07.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [30.07.2018]
     * @param {AnyT} event
     */
    onChange(event: AnyT): void;
    /**
     * @stable [30.07.2018]
     */
    clearValue(): void;
    /**
     * @stable [31.07.2018]
     * @returns {JSX.Element}
     */
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [01.08.2018]
     * @returns {string | number}
     */
    protected buildValue(): string | number;
    /**
     * @stable [01.08.2018]
     * @param {string} value
     * @returns {string}
     */
    protected validateValue(value: string): string;
    /**
     * @stable [31.07.2018]
     */
    private onPlaceChanged;
    /**
     * @stable [31.07.2018]
     */
    private onDialogAccept;
    /**
     * @stable [31.07.2018]
     */
    private onDialogClose;
    /**
     * @stable [31.07.2018]
     */
    private propsChangePlace;
    /**
     * @stable [31.07.2018]
     */
    private initGoogleMapsObjects;
    /**
     * @stable [31.07.2018]
     * @param {IGoogleMapsSelectEntity} payload
     */
    private onMenuSelect;
    /**
     * @stable [31.07.2018]
     * @param {IGoogleMapsMarkerChangePlaceEntity} place
     */
    private onMarkerChangePlace;
    /**
     * @stable [30.07.2018]
     * @returns {boolean}
     */
    private readonly isPlaceChanged;
    /**
     * @stable [31.07.2018]
     */
    private updateGeocodeInfo;
    /**
     * @stable [31.07.2018]
     */
    private cancelGeoCoderTaskIfPending;
    /**
     * @stable [31.07.2018]
     */
    private cancelTaskIfPending;
    /**
     * @stable [31.07.2018]
     * @param {google.maps.GeocoderResult[]} geocoderResults
     * @returns {google.maps.GeocoderResult[]}
     */
    private onGeocodeInfoLoad;
    /**
     * @stable [31.07.2018]
     */
    private resetAllStateOnChangeOrClearValue;
    /**
     * @stable [30.07.2018]
     */
    private clearInternalVariables;
    /**
     * @stable [29.07.2018]
     */
    private addMapAction;
    /**
     * @stable [30.07.2018]
     */
    private openDialog;
    /**
     * @stable [29.07.2018]
     * @returns {IUniversalDialog}
     */
    private readonly dialog;
    /**
     * @stable [31.07.2018]
     * @returns {IGoogleMaps}
     */
    private readonly googleMaps;
}
