/// <reference types="react" />
import { ILogger } from 'ts-smart-logger';
import { BasicTextField } from '../textfield';
import { EntityIdT, IKeyboardEvent } from '../../../definitions.interface';
import { MultiFieldPlugin } from '../multifield';
import { IBasicFileFieldInternalState, IBasicFileFieldInternalProps } from './basic-filefield.interface';
import { IBasicEvent } from '../../../react-definitions.interface';
export declare class BasicFileField<TComponent extends BasicFileField<TComponent, TProps, TInternalState>, TProps extends IBasicFileFieldInternalProps, TInternalState extends IBasicFileFieldInternalState> extends BasicTextField<TComponent, TProps, TInternalState> {
    protected static readonly logger: ILogger;
    protected multiFieldPlugin: MultiFieldPlugin;
    private filesMap;
    /**
     * @stable [30.06.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [28.06.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [28.06.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyEnter(event: IKeyboardEvent): void;
    /**
     * @stable [28.06.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyBackspace(event: IKeyboardEvent): void;
    clearValue(): void;
    /**
     * @stable [28.06.2018]
     * @param {IBasicEvent} event
     */
    protected onClick(event: IBasicEvent): void;
    /**
     * @stable [03.08.2018]
     * @returns {JSX.Element}
     */
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [02.08.2018]
     * @returns {EntityIdT[]}
     */
    protected getEmptyValue(): EntityIdT[];
    /**
     * @stable [05.10.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [02.08.2018]
     */
    private onCameraDialogClose;
    /**
     * @stable [02.08.2018]
     */
    private onCameraDialogAccept;
    /**
     * @stable [02.08.2018]
     * @param {File[]} file
     */
    private onSelect;
    /**
     * @stable [02.08.2018]
     * @param {Blob} blob
     */
    private doSelectBlob;
    private readonly dnd;
    /**
     * @stable [02.08.2018]
     * @param {IBasicEvent} event
     */
    private openCameraDialog;
    /**
     * @stable [28.06.2018]
     * @param {IBasicEvent} event
     */
    private openFileDialog;
    /**
     * @stable [28.06.2018]
     * @param {IBasicEvent} event
     */
    private downloadFile;
    /**
     * @stable [28.06.2018]
     * @param {EntityIdT} key
     */
    private destroyBlob;
    /**
     * @stable [02.08.2018]
     * @returns {IUniversalDialog}
     */
    private readonly cameraDialog;
    /**
     * @stable [02.08.2018]
     * @returns {IWebCamera}
     */
    private readonly camera;
}
