import { IEntity } from '../../../definitions.interface';
import { IMultiItemEntity } from '../../../entities-definitions.interface';
import { VueField } from '../field/vue-index';
import { MultiFieldPlugin } from '../multifield/vue-index';
import { IVueFileViewerPropsEntity, IVueViewerListenersEntity } from '../../viewer/vue-index';
import { IVueBaseFileFieldTemplateMethodsEntity } from './vue-filefield.interface';
export declare class VueBaseFileField extends VueField implements IVueBaseFileFieldTemplateMethodsEntity {
    protected readonly type: string;
    protected readonly viewer: string;
    protected readonly emptyMessageFactory: (index: number) => string;
    protected readonly viewerProps: IVueFileViewerPropsEntity;
    protected readonly multiFieldPlugin: MultiFieldPlugin;
    protected readonly cachedFiles: Map<string, File>;
    /**
     * @stable [27.11.2018]
     */
    constructor();
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    getFieldClassName(): string;
    /**
     * @stable [28.11.2018]
     * @param {File[]} files
     * @returns {string[]}
     */
    onFilesSelect(files: File[]): string[];
    /**
     * @stable [09.12.2018]
     * @param {number} index
     * @returns {string}
     */
    getLabel(index: number): string;
    getFiles(): IEntity[];
    /**
     * @stable [09.12.2018]
     * @param {IMultiItemEntity} entity
     * @param {number} index
     * @returns {IVueFileViewerPropsEntity}
     */
    getViewerBindings(entity: IMultiItemEntity, index: number): IVueFileViewerPropsEntity;
    /**
     * @stable [10.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @returns {IVueViewerListenersEntity<File>}
     */
    getViewerListeners(fileEntity: IMultiItemEntity): IVueViewerListenersEntity<File>;
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    protected getInputClassName(): string;
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    protected getFieldAttachmentTemplate(): string;
    /**
     * @stable [10.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @param {File} file
     */
    protected onFileChange(fileEntity: IMultiItemEntity, file: File): void;
    /**
     * @stable [10.12.2018]
     * @returns {IVueBaseFileFieldTemplateMethodsEntity}
     */
    protected getTemplateMethods(): IVueBaseFileFieldTemplateMethodsEntity;
    /**
     * @stable [10.12.2018]
     * @param {File} file
     * @returns {string}
     */
    private toFileUrl;
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    private destroyFileUrl;
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    private addFile;
    /**
     * @stable [28.11.2018]
     * @param {IMultiItemEntity} fileEntity
     */
    private removeFile;
}
