"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../field/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var VueBaseFileField = /** @class */ (function (_super) {
    __extends(VueBaseFileField, _super);
    /**
     * @stable [27.11.2018]
     */
    function VueBaseFileField() {
        var _this = _super.call(this) || this;
        _this.multiFieldPlugin = new vue_index_2.MultiFieldPlugin(_this);
        _this.cachedFiles = new Map();
        _this.onFileChange = _this.onFileChange.bind(_this);
        _this.onFilesSelect = _this.onFilesSelect.bind(_this);
        _this.getViewerBindings = _this.getViewerBindings.bind(_this);
        _this.getViewerListeners = _this.getViewerListeners.bind(_this);
        _this.getLabel = _this.getLabel.bind(_this);
        _this.getFiles = _this.getFiles.bind(_this);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-file-field";
    };
    /**
     * @stable [28.11.2018]
     * @param {File[]} files
     * @returns {string[]}
     */
    VueBaseFileField.prototype.onFilesSelect = function (files) {
        var _this = this;
        return Array.from(files).map(function (file) {
            var url = _this.toFileUrl(file);
            _this.addFile(url); // TODO Need to many files handling
            return url;
        });
    };
    /**
     * @stable [09.12.2018]
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getLabel = function (index) {
        return util_1.isFn(this.emptyMessageFactory)
            ? this.emptyMessageFactory(index)
            : this.settings.messages.dndMessage;
    };
    // TODO
    VueBaseFileField.prototype.getFiles = function () {
        return [];
    };
    /**
     * @stable [09.12.2018]
     * @param {IMultiItemEntity} entity
     * @param {number} index
     * @returns {IVueFileViewerPropsEntity}
     */
    VueBaseFileField.prototype.getViewerBindings = function (entity, index) {
        var _this = this;
        var props = __assign({}, this.viewerProps, { label: this.getLabel(index) });
        if (entity.newEntity) {
            var relationId_1 = entity.id;
            return __assign({}, props, { src: relationId_1, fileName: util_1.orNull(this.cachedFiles.has(relationId_1), function () { return _this.cachedFiles.get(relationId_1).name; }) });
        }
        return __assign({}, props, { src: Reflect.get(entity, this.displayName), entity: entity });
    };
    /**
     * @stable [10.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @returns {IVueViewerListenersEntity<File>}
     */
    VueBaseFileField.prototype.getViewerListeners = function (fileEntity) {
        var _this = this;
        return {
            change: function (file) { return _this.onFileChange(fileEntity, file); },
            remove: function () { return _this.removeFile(fileEntity); },
        };
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getInputClassName = function () {
        return _super.prototype.getInputClassName.call(this) + " rac-flex-full";
    };
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldAttachmentTemplate = function () {
        return ("<div class=\"vue-field-attachment-wrapper\">\n          <template v-for=\"(file, index) in getFiles()\">\n            <component v-if=\"file\"\n                       :is=\"getViewerComponent()\"\n                       v-on=\"getViewerListeners(file, index)\"\n                       v-bind=\"getViewerBindings(file, index)\"/>\n            <vue-dnd v-if=\"!file\"\n                    :defaultMessage=\"getLabel(index)\"\n                    @select=\"onFilesSelect\"/>\n          </template>\n       </div>");
    };
    /**
     * @stable [10.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @param {File} file
     */
    VueBaseFileField.prototype.onFileChange = function (fileEntity, file) {
        var _this = this;
        var newFileUrl = this.toFileUrl(file);
        if (fileEntity.newEntity) {
            this.removeFile(fileEntity);
            this.$nextTick(function () { return _this.addFile(newFileUrl); });
        }
        else {
            this.multiFieldPlugin.onEditItem({ id: fileEntity.id, name: this.displayName, value: newFileUrl });
        }
    };
    /**
     * @stable [10.12.2018]
     * @returns {IVueBaseFileFieldTemplateMethodsEntity}
     */
    VueBaseFileField.prototype.getTemplateMethods = function () {
        var _this = this;
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onFilesSelect: this.onFilesSelect, getFiles: this.getFiles, getLabel: this.getLabel, getViewerComponent: function () { return _this.viewer; }, getViewerListeners: this.getViewerListeners, getViewerBindings: this.getViewerBindings });
    };
    /**
     * @stable [10.12.2018]
     * @param {File} file
     * @returns {string}
     */
    VueBaseFileField.prototype.toFileUrl = function (file) {
        var newFileUrl = URL.createObjectURL(file);
        this.cachedFiles.set(newFileUrl, file);
        return newFileUrl;
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.destroyFileUrl = function (fileUrl) {
        this.cachedFiles.delete(fileUrl);
        URL.revokeObjectURL(fileUrl);
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.addFile = function (fileUrl) {
        this.multiFieldPlugin.onAddItem({ id: fileUrl, newEntity: true });
    };
    /**
     * @stable [28.11.2018]
     * @param {IMultiItemEntity} fileEntity
     */
    VueBaseFileField.prototype.removeFile = function (fileEntity) {
        this.multiFieldPlugin.onDeleteItem(fileEntity);
        this.destroyFileUrl(fileEntity.id);
    };
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'hidden'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "type", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'vue-file-viewer'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "viewer", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "emptyMessageFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseFileField.prototype, "viewerProps", void 0);
    return VueBaseFileField;
}(vue_index_1.VueField));
exports.VueBaseFileField = VueBaseFileField;
//# sourceMappingURL=vue-base-filefield.component.js.map