/// <reference types="react" />
import { ILogger } from 'ts-smart-logger';
import { IEventManager } from '../../../event';
import { IFieldActionConfiguration } from '../../../configurations-definitions.interface';
import { Field, IField } from '../field';
import { IKeyboardConfiguration } from '../../keyboard';
import { IBasicTextFieldState, IBasicTextFieldProps, IBasicTextField } from './basic-textfield.interface';
export declare class BasicTextField<TComponent extends IField<TInternalProps, TInternalState>, TInternalProps extends IBasicTextFieldProps, TInternalState extends IBasicTextFieldState> extends Field<TComponent, TInternalProps, TInternalState> implements IBasicTextField<TInternalProps, TInternalState> {
    protected static logger: ILogger;
    private static DEFAULT_MASK_GUIDE;
    protected eventManager: IEventManager;
    protected defaultActions: IFieldActionConfiguration[];
    private mirrorInputRef;
    constructor(props: TInternalProps);
    /**
     * @stable [15.09.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    protected getInputElement(): JSX.Element;
    /**
     * @stable [01.06.2018]
     * @returns {JSX.Element}
     */
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [07.11.2018]
     * @returns {string}
     */
    protected getSelfElementClassName(): string;
    protected addClearAction(): void;
    /**
     * @stable [03.09.2018]
     * @returns {JSX.Element}
     */
    protected toKeyboardElement(): JSX.Element;
    /**
     * @stable [21.11.2018]
     * @returns {IKeyboardConfiguration}
     */
    protected getKeyboardConfiguration(): IKeyboardConfiguration;
    /**
     * @stable [20.08.2018]
     */
    protected openSyntheticKeyboard(): boolean;
    /**
     * @stable [04.09.2018]
     */
    protected onCloseKeyboard(): boolean;
    /**
     * @stable [04.09.2018]
     */
    protected refreshCaretPosition(): void;
    /**
     * @stable [04.09.2018]
     * @returns {number}
     */
    protected getCaretPosition(): number;
    /**
     * @stable [16.05.2018]
     * @param {IBasicEvent} e
     */
    private onWindowMouseDown;
    private readonly actions;
    private getSelfElement;
    /**
     *
     * @returns {JSX.Element}
     */
    private getProgressLabelElement;
    /**
     * @stable [15.09.2018]
     * @returns {JSX.Element}
     */
    private getPrefixLabelElement;
    /**
     * @stable [12.09.2018]
     * @returns {JSX.Element}
     */
    private getMirrorInputElement;
    /**
     * @stable [03.10.2018]
     * @returns {JSX.Element}
     */
    private getLabelElement;
    /**
     * @stable [04.09.2018]
     * @returns {JSX.Element}
     */
    private getInputCaretElement;
    /**
     * @stable [04.09.2018]
     * @param {string} rawValue
     */
    private onKeyboardChange;
    /**
     * @stable [12.09.2018]
     * @returns {IJqElement}
     */
    private readonly jMirrorInput;
}
