/// <reference types="react" />
import { IApiEntity } from '../../entities-definitions.interface';
import { BaseComponent } from '../base';
import { IForm, IFormProps } from './form.interface';
export declare class Form extends BaseComponent<IForm, IFormProps> implements IForm {
    static defaultProps: IFormProps;
    private static logger;
    private fieldsOptions;
    private readonly childrenMap;
    /**
     * @stable [29.05.2018]
     * @param {IFormProps} props
     */
    constructor(props: IFormProps);
    render(): JSX.Element;
    /**
     * @stable [12.09.2018]
     */
    componentDidMount(): void;
    componentWillUpdate(nextProps: Readonly<IFormProps>, nextState: Readonly<{}>, nextContext: {}): void;
    componentWillUnmount(): void;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    isFormValid(): boolean;
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     */
    submit(apiEntity: IApiEntity): void;
    /**
     * @stable - 11.04.2018
     * @returns {IApiEntity}
     */
    readonly apiEntity: IApiEntity;
    private onChange;
    /**
     * @stable [04.08.2018]
     * @param {IField} field
     */
    private onEmptyDictionary;
    private onLoadDictionary;
    private propsOnValid;
    /**
     * @stable - 11.04.2018
     * @param {BasicEventT} event
     */
    private onSubmit;
    private onReset;
    private resetGroupFieldsErrors;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormDisabled;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormDirty;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormEditable;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormSubmittable;
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldReadOnly;
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldDisabled;
    /**
     * @stable [16.11.2018]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldChangeable;
    private getFieldValue;
    private getFieldOriginalValue;
    private getFieldDisplayValue;
    private getFieldPredefinedOptions;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly entity;
    /**
     * @stable [10.06.2018]
     * @returns {IEntity}
     */
    private readonly originalEntity;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly changes;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly form;
}
