"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../../util");
var base_1 = require("../base");
var menu_1 = require("../menu");
var layout_1 = require("../layout");
var button_1 = require("../button");
var SubHeader = /** @class */ (function (_super) {
    __extends(SubHeader, _super);
    /**
     * @stable [08.10.2018]
     * @param {ISubHeaderProps} props
     */
    function SubHeader(props) {
        var _this = _super.call(this, props) || this;
        _this.menuRef = React.createRef();
        _this.onMoreOptionsClick = _this.onMoreOptionsClick.bind(_this);
        return _this;
    }
    /**
     * @stable [08.10.2018]
     * @returns {JSX.Element}
     */
    SubHeader.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var headerTitle = React.createElement("span", { className: 'rac-sub-header-section-title' }, props.title);
        return (React.createElement(layout_1.FlexLayout, { row: true, full: false, justifyContentEnd: true, alignItemsCenter: true, className: util_1.toClassName('rac-sub-header', props.subBorder && 'rac-sub-header-bordered', !R.isNil(props.navigationActionType) && 'rac-sub-header-navigated') },
            React.createElement(layout_1.FlexLayout, { row: true, full: R.isNil(props.items), alignItemsCenter: true },
                util_1.orNull(props.navigationActionType, function () { return (React.createElement(button_1.Button, { icon: props.navigationActionType, onClick: props.onNavigationActionClick, className: 'rac-button-navigation' })); }),
                util_1.orDefault(R.isNil(props.titleRenderer), headerTitle, function () { return props.titleRenderer(headerTitle); })),
            props.items,
            util_1.orNull(props.moreOptions, function () { return _this.uiFactory.makeIcon(__assign({}, props.moreOptionsConfiguration, { type: 'more_vert', onClick: _this.onMoreOptionsClick })); }),
            util_1.orNull(props.moreOptions, function () { return (React.createElement(menu_1.Menu, { ref: _this.menuRef, options: props.moreOptions, onSelect: props.onMoreOptionsSelect })); })));
    };
    /**
     * @stable [08.10.2018]
     */
    SubHeader.prototype.onMoreOptionsClick = function () {
        this.menuRef.current.show();
    };
    return SubHeader;
}(base_1.BaseComponent));
exports.SubHeader = SubHeader;
//# sourceMappingURL=sub-header.component.js.map