import { IPositionWrapper, IFieldWrapper, IUseUppercaseWrapper, IOnChangeWrapper, IOnCloseWrapper, ITypeWrapper, IValueWrapper, IWidthWrapper, IClassNameWrapper, ILayoutWrapper, IModeWrapper } from '../../definitions.interface';
import { IComponentConfiguration } from '../../configurations-definitions.interface';
/**
 * @stable [08.05.2018]
 */
export declare enum KeyboardKeyEnum {
    UPPERCASE = 0,
    CHANGE_LAYOUT = 1,
    LOWERCASE = 2,
    BACKSPACE = 3,
    SPACE = 4,
    ENTER = 5
}
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardKey extends IValueWrapper<string>, ITypeWrapper<KeyboardKeyEnum>, IClassNameWrapper, IWidthWrapper {
}
/**
 * @stable [08.05.2018]
 */
export declare const KEYBOARD_SPECIAL_KEYS: {
    UPPERCASE: string;
    LOWERCASE: string;
    BACK: string;
    SPACE: string;
    DIGITAL: string;
    LITERAL: string;
};
/**
 * @stable [08.05.2018]
 */
export declare const KEYBOARD_QWERTY_LAYOUT: KeyboardLayoutT;
/**
 * @stable [08.05.2018]
 */
export declare const KEYBOARD_QWERTY_DIGITAL_LAYOUT: KeyboardLayoutT;
/**
 * @stable [21.11.2018]
 */
export declare const KEYBOARD_NUMERIC_LAYOUT: KeyboardLayoutT;
export declare type KeyboardKeyT = string | IKeyboardKey;
export declare type KeyboardLayoutT = KeyboardKeyT[][];
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardConfiguration extends IComponentConfiguration, IFieldWrapper<HTMLInputElement | HTMLTextAreaElement>, ILayoutWrapper<KeyboardLayoutT[]>, IOnCloseWrapper {
}
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardEntity extends IOnChangeWrapper<string> {
}
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardProps extends IKeyboardEntity, IKeyboardConfiguration {
}
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardState extends IPositionWrapper, IModeWrapper<number>, IUseUppercaseWrapper {
}
