/// <reference types="react" />
import { IconDefinition } from '@fortawesome/free-solid-svg-icons';
import { IUIFactory } from '../../factory';
import { IUIIconConfiguration } from '../../../configurations-definitions.interface';
export declare class UIMaterialFactory implements IUIFactory {
    static ICONS_MAP: {
        retweet: IconDefinition;
        barcode: IconDefinition;
        dashboard: IconDefinition;
        warehouse: IconDefinition;
        minus_circle: IconDefinition;
        product: IconDefinition;
        supplier: IconDefinition;
        check_circle_regular: IconDefinition;
        shopping_basket: IconDefinition;
        shipping_fast: IconDefinition;
        stop_circle: IconDefinition;
        stop_circle_regular: IconDefinition;
        file: IconDefinition;
        menu: IconDefinition;
        category: IconDefinition;
        local_offer: IconDefinition;
        home: IconDefinition;
        long_arrow_alt_up: IconDefinition;
        long_arrow_alt_down: IconDefinition;
        long_arrow_alt_right: IconDefinition;
        long_arrow_alt_left: IconDefinition;
        level_down_alt: IconDefinition;
        timelapse: IconDefinition;
        arrow_up: IconDefinition;
        http: IconDefinition;
        exchange: IconDefinition;
        user_clock: IconDefinition;
        tablet: IconDefinition;
        chart_pie: IconDefinition;
        location: IconDefinition;
        location_on: IconDefinition;
        map_marker_alt: IconDefinition;
        search: IconDefinition;
        more_vert: IconDefinition;
        more_hor: IconDefinition;
        save: IconDefinition;
        refresh: IconDefinition;
        user_edit: IconDefinition;
        clear: IconDefinition;
        people_carry: IconDefinition;
        keyboard_arrow_left: IconDefinition;
        keyboard_arrow_right: IconDefinition;
        expand_more: IconDefinition;
        chevron_down: IconDefinition;
        chevron_up: IconDefinition;
        attention: IconDefinition;
        arrows_alt_h: IconDefinition;
        file_export: IconDefinition;
        block: IconDefinition;
        ban: IconDefinition;
        user_tie: IconDefinition;
        widgets: IconDefinition;
        taxi: IconDefinition;
        times_circle: IconDefinition;
        spa: IconDefinition;
        add: IconDefinition;
        plus: IconDefinition;
        lock: IconDefinition;
        exchange_alt: IconDefinition;
        warning: IconDefinition;
        exclamation_triangle: IconDefinition;
        exclamation_circle: IconDefinition;
        close: IconDefinition;
        times: IconDefinition;
        lock_open: IconDefinition;
        filter_list: IconDefinition;
        error_outline: IconDefinition;
        done: IconDefinition;
        object_group_regular: IconDefinition;
        check: IconDefinition;
        first_page: IconDefinition;
        last_page: IconDefinition;
        date_range: IconDefinition;
        payment: IconDefinition;
        user_circle: IconDefinition;
        comment_regular: IconDefinition;
        file_invoice_dollar: IconDefinition;
        shopping_cart: IconDefinition;
        truck: IconDefinition;
        exit_to_app: IconDefinition;
        signIn: IconDefinition;
        group: IconDefinition;
        people_outline: IconDefinition;
        person_outline: IconDefinition;
        user_regular: IconDefinition;
        person: IconDefinition;
        loyalty: IconDefinition;
        local_atm: IconDefinition;
        access_time: IconDefinition;
        history: IconDefinition;
        sms: IconDefinition;
        work: IconDefinition;
        verified_user: IconDefinition;
        shield_alt: IconDefinition;
        user_shield: IconDefinition;
        done_all: IconDefinition;
        remove: IconDefinition;
        minus: IconDefinition;
        clock_regular: IconDefinition;
        playlist_add_check: IconDefinition;
        check_circle: IconDefinition;
        contact_phone: IconDefinition;
        phone: IconDefinition;
        comments_regular: IconDefinition;
        contact_mail: IconDefinition;
        edit: IconDefinition;
        pen: IconDefinition;
        priority_high: IconDefinition;
        format_list_numbered: IconDefinition;
        attach_file: IconDefinition;
        help_outline: IconDefinition;
        question: IconDefinition;
        clear_all: IconDefinition;
        stop: IconDefinition;
        hdd: IconDefinition;
        backward: IconDefinition;
        down: IconDefinition;
        arrow_alt_circle_down: IconDefinition;
        arrow_alt_circle_up: IconDefinition;
        arrow_alt_circle_up_regular: IconDefinition;
        arrow_alt_circle_right: IconDefinition;
        arrow_alt_circle_right_regular: IconDefinition;
        print: IconDefinition;
        router: IconDefinition;
        error: IconDefinition;
        cloud_download: IconDefinition;
        cloud: IconDefinition;
        gift: IconDefinition;
        card_giftcard: IconDefinition;
        play_circle_regular: IconDefinition;
        navigate_before: IconDefinition;
        navigate_next: IconDefinition;
        plug: IconDefinition;
        info: IconDefinition;
        list_ul: IconDefinition;
        binoculars: IconDefinition;
        search_plus: IconDefinition;
        eye: IconDefinition;
        file_import: IconDefinition;
        houzz: IconDefinition;
        undo: IconDefinition;
        user: IconDefinition;
        minus_square: IconDefinition;
        arrow_right: IconDefinition;
        arrow_left: IconDefinition;
        user_plus: IconDefinition;
        plus_square: IconDefinition;
        thumbs_up: IconDefinition;
        id_card: IconDefinition;
        map_marked_alt: IconDefinition;
        address_card: IconDefinition;
        video: IconDefinition;
        store_alt: IconDefinition;
        key: IconDefinition;
        trash: IconDefinition;
        smile_beam: IconDefinition;
        adversal: IconDefinition;
    };
    private static logger;
    list: string;
    switch: string;
    switchInput: string;
    switchInputWrapper: string;
    switchInputWrapperBody: string;
    snackbar: string;
    snackbarText: string;
    snackbarActionWrapper: string;
    snackbarActionButton: string;
    icons: string;
    toolbar: string;
    tabBarScrollerScrollArea: string;
    tabBarScrollerScrollAreaScroll: string;
    tabBarScrollerScrollContent: string;
    tabRipple: string;
    tabBar: string;
    tab: string;
    tabContent: string;
    tabIcon: string;
    tabIconText: string;
    tabActive: string;
    tabIndicator: string;
    tabIndicatorActive: string;
    tabIndicatorContent: string;
    tabIndicatorContentUnderline: string;
    tabBarScroller: string;
    listItemMeta: string;
    listDivider: string;
    listGroupSubHeader: string;
    textFieldBox: string;
    checkbox: string;
    checkboxInput: string;
    card: string;
    cardActions: string;
    cardActionButtons: string;
    cardActionIcons: string;
    rippleSurface: string;
    menuAnchor: string;
    menuSurface: string;
    menu: string;
    fab: string;
    dialog: string;
    dialogSurface: string;
    dialogContent: string;
    dialogContainer: string;
    dialogTitle: string;
    dialogScrim: string;
    dialogActions: string;
    private t;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {JSX.Element}
     */
    makeIcon(cfg: IUIIconConfiguration | string): JSX.Element;
    /**
     * @stable [18.05.2018]
     * @param {IUIIconConfiguration | string} cfg
     * @returns {JSX.Element}
     */
    makeListItemMetaIcon(cfg: IUIIconConfiguration | string): JSX.Element;
    makeCheckboxAttachment(): JSX.Element;
    /**
     * @stable [30.08.2018]
     * @returns {JSX.Element}
     */
    makeSwitchAttachment(): JSX.Element;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {IUIIconConfiguration}
     */
    private toIconConfig;
}
