"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var dialog_1 = require("@material/dialog");
var util_1 = require("../../../util");
var material_plugin_1 = require("./material.plugin");
var DialogMaterialPlugin = /** @class */ (function (_super) {
    __extends(DialogMaterialPlugin, _super);
    /**
     * @stable [04.10.2018]
     * @param {TDialog} dialog
     */
    function DialogMaterialPlugin(dialog) {
        var _this = _super.call(this, dialog, dialog_1.MDCDialog) || this;
        dialog.activate = util_1.sequence(dialog.activate, _this.onMenuActivate, _this);
        dialog.onClose = util_1.sequence(dialog.onClose, _this.onClose, _this);
        dialog.onAccept = util_1.sequence(dialog.onAccept, _this.onAccept, _this);
        return _this;
    }
    /**
     * @stable [04.10.2018]
     */
    DialogMaterialPlugin.prototype.onMenuActivate = function () {
        this.mdc.open();
    };
    /**
     * @stable [04.10.2018]
     */
    DialogMaterialPlugin.prototype.onAccept = function () {
        this.mdc.close();
    };
    /**
     * @stable [04.10.2018]
     */
    DialogMaterialPlugin.prototype.onClose = function () {
        this.mdc.close();
    };
    return DialogMaterialPlugin;
}(material_plugin_1.MaterialPlugin));
exports.DialogMaterialPlugin = DialogMaterialPlugin;
//# sourceMappingURL=dialog-material.plugin.js.map