"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var vue_popup_interface_1 = require("./vue-popup.interface");
var VuePopup = /** @class */ (function (_super) {
    __extends(VuePopup, _super);
    function VuePopup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [26.11.2018]
     */
    VuePopup.prototype.onOpenUpdate = function () {
        var _this = this;
        if (this.open) {
            this.$nextTick(function () { return util_1.addChild(_this.getPopupWrapper().$el); });
        }
    };
    /**
     * @stable [26.11.2018]
     * @returns {IVueComponent}
     */
    VuePopup.prototype.getPopupWrapper = function () {
        return this.$refs.popupWrapper;
    };
    /**
     * @stable [26.11.2018]
     */
    VuePopup.prototype.onOverlayClick = function () {
        this.$emit(vue_popup_interface_1.VUE_POPUP_CLOSE_EVENT);
    };
    /**
     * @stable [29.11.2018]
     * @returns {boolean}
     */
    VuePopup.prototype.hasFooterSlot = function () {
        return this.hasSlot(vue_popup_interface_1.VUE_POPUP_FOOTER_SLOT);
    };
    /**
     * @stable [29.11.2018]
     * @returns {boolean}
     */
    VuePopup.prototype.hasHeaderSlot = function () {
        return this.hasSlot(vue_popup_interface_1.VUE_POPUP_HEADER_SLOT);
    };
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'animated fadeIn'; } }),
        __metadata("design:type", String)
    ], VuePopup.prototype, "animationClasses", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VuePopup.prototype, "open", void 0);
    __decorate([
        vue_property_decorator_1.Watch('open'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], VuePopup.prototype, "onOpenUpdate", null);
    VuePopup = __decorate([
        vue_index_1.ComponentName('vue-popup'),
        vue_property_decorator_1.Component({
            template: "\n    <vue-flex-layout v-if=\"open\"\n                     ref=\"popupWrapper\"\n                     class=\"vue-popup-wrapper rac-absolute-full\">\n        <div class='rac-overlay rac-absolute-full'\n             :class=\"animationClasses\"\n             @click=\"onOverlayClick\"/>\n        <vue-flex-layout class=\"vue-popup\"\n                        :class=\"animationClasses\">\n            <vue-flex-layout v-if=\"hasHeaderSlot()\"\n                             :full=\"false\"\n                             class=\"vue-popup-header\">\n                <slot name=\"" + vue_popup_interface_1.VUE_POPUP_HEADER_SLOT + "\"/>\n            </vue-flex-layout>\n            <vue-flex-layout class=\"vue-popup-body\">\n                <slot/>\n            </vue-flex-layout>\n            <vue-flex-layout v-if=\"hasFooterSlot()\"\n                             :full=\"false\"\n                             class=\"vue-popup-footer\">\n                <slot name=\"" + vue_popup_interface_1.VUE_POPUP_FOOTER_SLOT + "\"/>\n            </vue-flex-layout>\n        </vue-flex-layout>\n    </vue-flex-layout>\n  ",
        })
    ], VuePopup);
    return VuePopup;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-popup.component.js.map