import { Store } from 'redux';
import { IUniversalApplicationStoreEntity } from '../entities-definitions.interface';
import { INumberConverter } from '../converter';
import { IUIFactory } from '../component/factory/factory.interface';
import { ApplicationTranslatorT } from '../translation';
/**
 * @stable [20.10.2018]
 * @returns {Store<TStoreEntity extends IUniversalApplicationStoreEntity>}
 */
export declare const getStore: <TStoreEntity extends IUniversalApplicationStoreEntity<{}>>() => Store<TStoreEntity>;
/**
 * @stable [31.10.2018]
 * @returns {INumberConverter}
 */
export declare const getNumberConverter: () => INumberConverter;
/**
 * @stable [09.11.2018]
 * @returns {IUIFactory}
 */
export declare const getUiFactory: () => IUIFactory;
/**
 * @stable [15.11.2018]
 * @returns {ApplicationTranslatorT}
 */
export declare const getTranslator: () => ApplicationTranslatorT;
