import { AnyT, IStringIdWrapper } from '../definitions.interface';
export interface ISetFileResult extends IStringIdWrapper {
    filePath: string;
}
export interface IRemoveFileResult {
}
export interface ISetFilesResult {
    setFilesResults: ISetFileResult[];
    removeFilesResults: IRemoveFileResult[];
}
export interface IApplicationStorage {
    enabled?: boolean;
    disabled?: boolean;
    set(key: string, value: AnyT): Promise<AnyT>;
    get?(key: string): Promise<AnyT>;
    remove?(key: string, noPrefix?: boolean): Promise<AnyT>;
    each?(command: (o: AnyT, key: string) => void): void;
}
/**
 * @stable [28.06.2018]
 */
export interface IApplicationStorageHelper {
    saveFiles<TEntity>(changes: TEntity, fields: Array<(entity: TEntity) => string>): Promise<ISetFilesResult[]>;
}
export declare enum ApplicationStorageTypeEnum {
    SESSION = 0,
    LOCAL = 1
}
export declare const STORAGE_KEY_SEPARATOR = "#";
export declare const APPLICATION_STATE_KEY = "$$state";
export declare const APPLICATION_TOKEN_KEY: string;
export declare const APPLICATION_UUID_KEY: string;
