"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var di_1 = require("../di");
var transport_factory_1 = require("./transport.factory");
var transport_service_1 = require("./transport.service");
var transport_payload_analyzer_1 = require("./transport-payload.analyzer");
var transport_error_interceptor_1 = require("./transport-error.interceptor");
var transport_request_factory_1 = require("./transport-request.factory");
var transport_token_accessor_1 = require("./transport-token.accessor");
var fetch_json_transport_factory_1 = require("./fetch-json-transport.factory");
require("./transport.effects");
di_1.appContainer.bind(di_1.DI_TYPES.TransportTokenAccessor).to(transport_token_accessor_1.TransportTokenAccessor).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportRequestFactory).to(transport_request_factory_1.TransportRequestFactory).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportFactory).to(transport_factory_1.TransportFactory).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.Transport).to(transport_service_1.TransportService).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportPayloadAnalyzer).to(transport_payload_analyzer_1.TransportPayloadAnalyzer).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportErrorInterceptor).to(transport_error_interceptor_1.TransportErrorInterceptor).inSingletonScope();
di_1.bindInSingleton(fetch_json_transport_factory_1.FetchJsonTransportFactory);
//# sourceMappingURL=transport.module.js.map