import { AnyT } from '../definitions.interface';
/**
 * @stable [25.10.2018]
 * @param {AnyT} condition
 * @param {string | (() => string)} result
 * @returns {string}
 */
export declare const orEmpty: (condition: any, result: string | (() => string)) => string;
export declare function orNull<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
export declare function orUndef<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
export declare function orDefault<TResult1, TResult2>(cond: boolean, result1: TResult1 | (() => TResult1), result2: TResult2 | (() => TResult2)): TResult1 | TResult2;
/**
 * @stable [06.12.2018]
 * @param {AnyT} value
 * @param {(() => TResult1) | TResult1} result1
 * @param {(() => TResult2) | TResult2} result2
 * @returns {TResult1 | TResult2}
 */
export declare const ifNilReturnDefault: <TResult1, TResult2 = any>(value: any, result1: TResult1 | (() => TResult1), result2?: TResult2 | (() => TResult2)) => TResult1 | TResult2;
/**
 * @stable [01.12.2018]
 * @param {AnyT} value
 * @param {(() => TResult) | TResult} result
 * @returns {void | TResult}
 */
export declare const ifNotNilReturnValue: <TResult>(value: any, result: TResult | (() => TResult)) => TResult;
/**
 * @stable [19.08.2018]
 * @param {AnyT} value
 * @param {(() => TResult) | TResult} result
 * @returns {string | TResult}
 */
export declare const ifNilReturnUuid: <TResult>(value: any, result: TResult | (() => TResult)) => string | TResult;
