"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var env_1 = require("../env");
/**
 * @stable [27.08.2018]
 * @param {string | Error | {}} error
 * @param {string} separator
 * @returns {string}
 */
exports.buildErrorMessage = function (error, separator) {
    if (separator === void 0) { separator = '\n'; }
    return [
        'Houston! We\'re in trouble!',
        'Please send this screen to the developers.',
        'Thank you!',
        "Build: " + env_1.ENV.appVersion,
        "Details info: [" + (function () {
            try {
                return JSON.stringify(error);
            }
            catch (e) {
                return error;
            }
        })() + "]"
    ].join(separator || '\n');
};
//# sourceMappingURL=message.js.map